% Exercise 48
%
% D.T. de Jong

a = [3 7 -2]';
r1 = [5 -1 3]';
r2 = [1 2 1]';
p = [1 2 1]';
q = 2*r1 - r2; 

% We have to solve: a+r1*c1+r2*c2 = p+lambda*q, which can be rewritten:
% r1*c1+r2*c2-q*lambda = p-a, which may be written as:
% A*v = b, where the matrix A has three columns:
A = [r1 r2 -q];
% and the vector v has the components c1, c2, and lambda.
b = p-a;

% Now, we can find c as follows:
c = A\b
Int_sec1 = [a+r1*c(1)+r2*c(2) p+q*c(3)]


% We now get a warning that A is singular, since the third column is a linear 
% combination of the first two columns. 

% Let us add a little bit of noise to q, so A is no longer singular
q = q + (rand(3,1)-0.5)*0.1
A = [r1 r2 -q];
c = A\b;

Int_sec2 = [a+r1*c(1)+r2*c(2) p+q*c(3)]








